import React, { useState, useMemo, useRef, useEffect } from 'react';
import DrawerPro from '@/components/DrawerPro';
import AutoTable from '@/components/AutoTable';
import PremButton from '@/components/PremButton';
import getcolumns from './columns';
import { doFetch } from '@/utils/doFetch';
import { useRequest } from "ahooks";
import styles from "./index.less";
import TreeRender from '@/components/TreeRender';
import { Divider, Tabs, ProDescriptions } from "antd";
import Account from "./Account";
import Basemsg from "./Basemsg";
const Devicedata = () => {
    let actionRef = useRef();
    const [drawer, setdrawer] = useState({
        visible: false,
    }),
        [activeKey, catk] = useState('item-1'),
        [currDrawer, setCurrDrawer] = useState({
            visible: false,
        });
    const { run, loading, runAsync } = useRequest(doFetch, {
        manual: true,
        onSuccess: (res, params) => {
            if (res?.code == "0000") {
                actionRef?.current?.reload();
                setdrawer((s) => ({
                    ...s,
                    visible: false,
                }));
            }
        },
    });
    const columns = useMemo(() => {
        let defcolumn = getcolumns(setdrawer, activeKey)?.columns ?? [];
        return defcolumn;
    }, [activeKey]);


    const items = useMemo(() => {
        if (drawer.val == 'only') {
            if (activeKey == 'item-1') {
                return [
                    { label: '基础信息', key: 'item-1', children: <Basemsg drawer={drawer} activeKey={activeKey} /> }
                ]
            }
        }
    }, [drawer.val, activeKey]);
    const tableItems = useMemo(() => {
        return [
            {
                label: '租赁设备',
                key: 'item-1',
                children: <AutoTable
                    pagetitle={'设备列表'}
                    columns={columns}
                    path=''
                    actionRef={actionRef}
                    resizeable={false}
                    dataSource={[{ 'f1': '111', 'f2': '222', id: 1, status: 1, f12: 1, intelligentUnit: '11' }]}
                    bordered={false}
                    x={1500}
                />
            },
            {
                label: '自主设备',
                key: 'item-2',
                children: <Account />
            }
        ]
    }, [columns]);
    const onselecteTree = async (selectedKeys, e, alldata) => {
        // let params = {
        //   treeNodeType: e.node.type,
        //   treeNodeKey: e.node.key,
        // };
        // setextraparams(params);
    };
    const selectValueType = (type, options) => {
        switch (type) {
            case 1:
                return {
                    valueType: 'input',
                };
            case 2:
                return {
                    valueType: 'select',
                    options,
                };
            case 3:
                return {
                    valueType: 'radio',
                    options,
                };
            case 4:
                return {
                    valueType: 'select',
                    options,
                };
            default:
                break;
        }
    };
    const fn2 = async () => {
        const res = await doFetch({
            url: urlParams.detail,
            params: { id: drawer?.item?.id },
        });
        let obj = {};
        res?.data?.data['equipmentCharList']?.forEach?.((it) => {
            obj[it?.fieldId] = it?.fieldRealValue;
        });
        console.log('drawerpro:', {
            ...(res?.data?.data ?? {}),
            ...obj,
        });
        setrequest(
            {
                ...(res?.data?.data ?? {}),
                ...obj,
            } ?? {},
        );
    };


    return <div className={styles.ledgerbox}>
        <div className={styles.ledgerheader}>
            <div className="ant-card-head" style={{ backgroundColor: 'white' }}>
                <div className="ant-card-head-wrapper">
                    <div className="ant-card-head-title">
                        <h3 className="page-title">设备台账</h3>
                    </div>
                </div>
            </div>
        </div>
        <div className={styles.ledgercontent}>
            <div className={styles.ledgerleft}>
                <TreeRender url="/auth/sysFactory/getTree" onselected={onselecteTree} noaction={true} />
            </div>
            <div className={styles.ledgerright}>
                <Tabs activeKey={activeKey} onChange={(key) => {
                    catk(key);
                }} items={tableItems} />
            </div>
        </div>


        <DrawerPro
            {...drawer}
            fields={columns}
            params={{ id: drawer?.item?.id }}
            defaultFormValue={drawer?.item ?? {}}
            placement="right"
            onClose={() => {
                setdrawer((s) => ({
                    ...s,
                    visible: false,
                }));
            }}
        >
            <Tabs items={items} />
        </DrawerPro>
    </div>
}
export default Devicedata;